3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
32 # Resolve relative url by appending to parent's url
33 resolve_relative_url ()
35 remote=$(get_default_remote)
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
39 remoteurl=${remoteurl%/}
45 remoteurl="${remoteurl%/*}"
54 echo "$remoteurl/${url%/}"
58 # Get submodule info for registered submodules
59 # $@ = path to limit submodule list
63 git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
67 # Map submodule path to submodule name
73 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
74 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
75 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
76 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
78 die "No submodule mapping found in .gitmodules for path '$path'"
85 # Prior to calling, cmd_update checks that a possibly existing
86 # path is not a git repository.
87 # Likewise, cmd_add checks that path does not exist at all,
88 # since it is the location of a new submodule.
96 # If there already is a directory at the submodule path,
97 # expect it to be empty (since that is the default checkout
98 # action) and try to remove it.
99 # Note: if $path is a symlink to a directory the test will
100 # succeed but the rmdir will fail. We might want to fix this.
103 rmdir "$path" 2>/dev/null ||
104 die "Directory '$path' exists, but is neither empty nor a git repository"
108 die "A file already exist at path '$path'"
110 if test -n "$reference"
112 git-clone "$reference" -n "$url" "$path"
114 git-clone -n "$url" "$path"
116 die "Clone of '$url' into submodule path '$path' failed"
120 # Add a new submodule to the working tree, .gitmodules and the index
124 # optional branch is stored in global branch variable
128 # parse $args after "submodule ... add".
133 case "$2" in '') usage ;; esac
144 case "$2" in '') usage ;; esac
145 reference="--reference=$2"
169 if test -z "$path"; then
170 path=$(echo "$repo" |
171 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
174 if test -z "$repo" -o -z "$path"; then
178 # assure repo is absolute or relative to parent
181 # dereference source url relative to parent's url
182 realrepo=$(resolve_relative_url "$repo") || exit
189 die "repo URL: '$repo' must be absolute or begin with ./|../"
194 # multiple //; leading ./; /./; /../; trailing /
195 path=$(printf '%s/\n' "$path" |
205 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
206 die "'$path' already exists in the index"
208 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
210 echo >&2 "The following path is ignored by one of your .gitignore files:" &&
212 echo >&2 "Use -f if you really want to add it."
216 # perhaps the path exists and is already a git repo, else clone it
219 if test -d "$path"/.git -o -f "$path"/.git
221 echo "Adding existing repo at '$path' to the index"
223 die "'$path' already exists and is not a valid git repo"
228 url=$(resolve_relative_url "$repo") || exit
234 git config submodule."$path".url "$url"
237 module_clone "$path" "$realrepo" "$reference" || exit
241 # ash fails to wordsplit ${branch:+-b "$branch"...}
243 '') git checkout -f -q ;;
244 ?*) git checkout -f -q -b "$branch" "origin/$branch" ;;
246 ) || die "Unable to checkout submodule '$path'"
249 git add $force "$path" ||
250 die "Failed to add submodule '$path'"
252 git config -f .gitmodules submodule."$path".path "$path" &&
253 git config -f .gitmodules submodule."$path".url "$repo" &&
254 git add --force .gitmodules ||
255 die "Failed to register submodule '$path'"
259 # Execute an arbitrary command sequence in each checked out
262 # $@ = command to execute
266 # parse $args after "submodule ... foreach".
289 while read mode sha1 stage path
291 if test -e "$path"/.git
293 say "Entering '$prefix$path'"
294 name=$(module_name "$path")
296 prefix="$prefix$path/"
300 if test -n "$recursive"
302 cmd_foreach "--recursive" "$@"
305 die "Stopping at '$path'; script returned non-zero status."
311 # Register submodules in .git/config
313 # $@ = requested paths (default to all)
317 # parse $args after "submodule ... init".
339 while read mode sha1 stage path
341 # Skip already registered paths
342 name=$(module_name "$path") || exit
343 url=$(git config submodule."$name".url)
344 test -z "$url" || continue
346 url=$(git config -f .gitmodules submodule."$name".url)
348 die "No url found for submodule path '$path' in .gitmodules"
350 # Possibly a url relative to parent
353 url=$(resolve_relative_url "$url") || exit
357 git config submodule."$name".url "$url" ||
358 die "Failed to register url for submodule path '$path'"
360 upd="$(git config -f .gitmodules submodule."$name".update)"
362 git config submodule."$name".update "$upd" ||
363 die "Failed to register update mode for submodule path '$path'"
365 say "Submodule '$name' ($url) registered for path '$path'"
370 # Update each submodule path to correct revision, using clone and checkout as needed
372 # $@ = requested paths (default to all)
376 # parse $args after "submodule ... update".
398 case "$2" in '') usage ;; esac
399 reference="--reference=$2"
429 cmd_init "--" "$@" || return
433 while read mode sha1 stage path
435 name=$(module_name "$path") || exit
436 url=$(git config submodule."$name".url)
437 update_module=$(git config submodule."$name".update)
440 # Only mention uninitialized submodules when its
441 # path have been specified
443 say "Submodule path '$path' not initialized" &&
444 say "Maybe you want to use 'update --init'?"
448 if ! test -d "$path"/.git -o -f "$path"/.git
450 module_clone "$path" "$url" "$reference"|| exit
453 subsha1=$(clear_local_git_env; cd "$path" &&
454 git rev-parse --verify HEAD) ||
455 die "Unable to find current revision in submodule path '$path'"
458 if ! test -z "$update"
460 update_module=$update
463 if test "$subsha1" != "$sha1"
466 if test -z "$subsha1"
471 if test -z "$nofetch"
473 (clear_local_git_env; cd "$path" &&
475 die "Unable to fetch in submodule path '$path'"
478 case "$update_module" in
490 command="git checkout $force -q"
496 (clear_local_git_env; cd "$path" && $command "$sha1") ||
497 die "Unable to $action '$sha1' in submodule path '$path'"
498 say "Submodule path '$path': $msg '$sha1'"
501 if test -n "$recursive"
503 (clear_local_git_env; cd "$path" && cmd_update $orig_args) ||
504 die "Failed to recurse into submodule path '$path'"
513 git describe "$2" 2>/dev/null ||
514 git describe --tags "$2" 2>/dev/null ||
515 git describe --contains "$2" 2>/dev/null ||
516 git describe --all --always "$2"
519 test -z "$revname" || revname=" ($revname)"
522 # Show commit summary for submodules in index or working tree
524 # If '--cached' is given, show summary between index and given commit,
525 # or between working tree and given commit
527 # $@ = [commit (default 'HEAD'),] requested paths (default all)
534 # parse $args after "submodule ... summary".
548 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
570 test $summary_limit = 0 && return
572 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
576 elif test -z "$1" -o "$1" = "HEAD"
578 # before the first commit: compare with an empty tree
579 head=$(git hash-object -w -t tree --stdin </dev/null)
580 test -z "$1" || shift
588 die "--cached cannot be used with --files"
594 # Get modified modules cared by user
595 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
596 sane_egrep '^:([0-7]* )?160000' |
597 while read mod_src mod_dst sha1_src sha1_dst status name
599 # Always show modules deleted or type-changed (blob<->module)
600 test $status = D -o $status = T && echo "$name" && continue
601 # Also show added or modified modules which are checked out
602 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
607 test -z "$modules" && return
609 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
610 sane_egrep '^:([0-7]* )?160000' |
612 while read mod_src mod_dst sha1_src sha1_dst status name
614 if test -z "$cached" &&
615 test $sha1_dst = 0000000000000000000000000000000000000000
619 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
621 100644 | 100755 | 120000)
622 sha1_dst=$(git hash-object $name)
628 echo >&2 "unexpected mode $mod_dst"
635 test $mod_src = 160000 &&
636 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
639 test $mod_dst = 160000 &&
640 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
644 case "$missing_src,$missing_dst" in
646 errmsg=" Warn: $name doesn't contain commit $sha1_src"
649 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
652 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
657 if test $mod_src = 160000 -a $mod_dst = 160000
659 range="$sha1_src...$sha1_dst"
660 elif test $mod_src = 160000
666 GIT_DIR="$name/.git" \
667 git rev-list --first-parent $range -- | wc -l
669 total_commits=" ($(($total_commits + 0)))"
673 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
674 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
677 if test $mod_dst = 160000
679 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
681 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
684 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
688 # Don't give error msg for modification whose dst is not submodule
689 # i.e. deleted or changed to blob
690 test $mod_dst = 160000 && echo "$errmsg"
692 if test $mod_src = 160000 -a $mod_dst = 160000
695 test $summary_limit -gt 0 && limit="-$summary_limit"
696 GIT_DIR="$name/.git" \
697 git log $limit --pretty='format: %m %s' \
698 --first-parent $sha1_src...$sha1_dst
699 elif test $mod_dst = 160000
701 GIT_DIR="$name/.git" \
702 git log --pretty='format: > %s' -1 $sha1_dst
704 GIT_DIR="$name/.git" \
705 git log --pretty='format: < %s' -1 $sha1_src
711 if test -n "$for_status"; then
712 if [ -n "$files" ]; then
713 echo "# Submodules changed but not updated:"
715 echo "# Submodule changes to be committed:"
718 sed -e 's|^|# |' -e 's|^# $|#|'
724 # List all submodules, prefixed with:
725 # - submodule not initialized
726 # + different revision checked out
728 # If --cached was specified the revision in the index will be printed
729 # instead of the currently checked out revision.
731 # $@ = requested paths (default to all)
735 # parse $args after "submodule ... status".
764 while read mode sha1 stage path
766 name=$(module_name "$path") || exit
767 url=$(git config submodule."$name".url)
768 displaypath="$prefix$path"
769 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
771 say "-$sha1 $displaypath"
774 set_name_rev "$path" "$sha1"
775 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
777 say " $sha1 $displaypath$revname"
781 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
782 set_name_rev "$path" "$sha1"
784 say "+$sha1 $displaypath$revname"
787 if test -n "$recursive"
790 prefix="$displaypath/"
793 cmd_status $orig_args
795 die "Failed to recurse into submodule path '$path'"
800 # Sync remote urls for submodules
801 # This makes the value for remote.$remote.url match the value
802 # specified in .gitmodules.
827 while read mode sha1 stage path
829 name=$(module_name "$path")
830 url=$(git config -f .gitmodules --get submodule."$name".url)
832 # Possibly a url relative to parent
835 url=$(resolve_relative_url "$url") || exit
839 if test -e "$path"/.git
842 say "Synchronizing submodule url for '$name'"
843 git config submodule."$name".url "$url"
846 remote=$(get_default_remote)
847 git config remote."$remote".url "$url"
853 # This loop parses the command line arguments to find the
854 # subcommand name to dispatch. Parsing of the subcommand specific
855 # options are primarily done by the subcommand implementations.
856 # Subcommand specific options such as --branch and --cached are
857 # parsed here as well, for backward compatibility.
859 while test $# != 0 && test -z "$command"
862 add | foreach | init | update | status | summary | sync)
892 # No command word defaults to "status"
893 test -n "$command" || command=status
895 # "-b branch" is accepted only by "add"
896 if test -n "$branch" && test "$command" != add
901 # "--cached" is accepted only by "status" and "summary"
902 if test -n "$cached" && test "$command" != status -a "$command" != summary